﻿using System;

namespace MetodaSzablonowa
{
    using static Console;

    public abstract class Pizza
    {
        private void przygotuj()
        {
            przygotujCiasto();
            dodajSos();
            połóżDodatki();
            dodajPrzyprawy();
            upiecz();
        }

        public Pizza()
        {
            przygotuj();
        }

        private void dodajSosPomidorowy()
        {
            WriteLine("Dodaj sos pomidorowy");
        }

        protected virtual void dodajSos()
        {
            dodajSosPomidorowy();
        }

        private void upiecz()
        {
            WriteLine("Włączam pieczenie na " + pobierzCzasPieczenia());
        }

        protected virtual string pobierzCzasPieczenia()
        {
            return "15 minut";
        }

        protected abstract void przygotujCiasto();
        protected abstract void połóżDodatki();
        protected abstract void dodajPrzyprawy();
    }

    public class PizzaMargerita : Pizza
    {
        protected override void przygotujCiasto()
        {
            WriteLine("Przygotowuję cieńkie ciasto");
        }

        protected override void połóżDodatki()
        {
            WriteLine("Dodaj ser mozarella");
        }

        protected override void dodajPrzyprawy()
        {
            WriteLine("Dodaj bazylię i odrobinę oliwy");
        }
    }

    public class PizzaSycylijska : Pizza
    {
        protected override void przygotujCiasto()
        {
            WriteLine("Przygotuj grube ciasto");
        }

        protected override void połóżDodatki()
        {
            WriteLine("Dodaję oliwki i kapary");
        }

        protected override void dodajPrzyprawy()
        {
            WriteLine("Dodaje specjalną mieszankę przypraw");
        }

        protected override string pobierzCzasPieczenia()
        {
            return "20 minut";
        }
    }
}
